program checkoutput
use dal
use errorhandling

implicit none

type(DataSetT)  :: inBPXF
type(TableT)    :: BPXFtable
type(ColumnT)   :: xCol, yCol 
integer(int16), dimension(:), pointer ::p_x, p_y 
integer i,nrows
logical ok

ok = .true. 
!-------------------------------------------------------------------------
write(*,*) 'testing MOS mode2 output'
inBPXF = dataSet("bpxfmos", read)
if (.not.hasBlock(inBPXF,"BADPIX")) ok = .false. 
if (.not.ok) call error("noExt","MOS Extension absent or incorrectly named")
ok = .true.
BPXFtable = table(inBPXF,"BADPIX")
if (.not.hasColumn(BPXFtable,"RAWX") .or. &
    .not.hasColumn(BPXFtable,"RAWY") .or. &
    .not.hasColumn(BPXFtable,"TYPE") .or. &
    .not.hasColumn(BPXFtable,"YEXTENT")) ok = .false.
if (.not.ok) call error("noColumn","MOS Column absent or incorrectly named")
ok = .true.
xCol = column(BPXFtable, "RAWX",read)
yCol = column(BPXFtable, "RAWY",read)
nrows = numberofRows(BPXFtable)
p_x => int16Data(xCol)
p_y => int16Data(yCol)
do i = 0,  nrows-1
  if (p_x(i) < 1.0 .or. p_y(i) < 1.0 .or. &
      p_x(i) > 600 .or. p_y(i) > 600) ok = .false.
enddo
if (.not.ok) call error("wrongCoords","MOS Coordinates out of range")
ok = .true.
if (p_x(0) .ne. 3 .or. p_y(0) .ne. 5) ok = .false.
if (.not.ok) call error("wrongValues","MOS Coordinate values wrong")
ok = .true.
call release(inBPXF)
!________________________________________________________________
!	PN
write (*,*) 'testing PN output'
inBPXF = dataSet("bpxfpn", read)
if (.not.hasBlock(inBPXF,"BADPIX")) ok = .false. 
if (.not.ok) call error("noExt","PN BADPIX Extension absent or incorrectly named")
ok = .true.
BPXFtable = table(inBPXF,"BADPIX")
if (.not.hasColumn(BPXFtable,"RAWX") .or. &
    .not.hasColumn(BPXFtable,"RAWY") .or. &
    .not.hasColumn(BPXFtable,"TYPE") .or. &
    .not.hasColumn(BPXFtable,"YEXTENT")) ok = .false.
if (.not.ok) call error("noColumn","PN BADPIX Column absent or incorrectly named")
ok = .true.
xCol = column(BPXFtable, "RAWX",read)
yCol = column(BPXFtable, "RAWY",read)
nrows = numberofRows(BPXFtable)
p_x => int16Data(xCol)
p_y => int16Data(yCol)
do i = 0,  nrows-1
  if (p_x(i) < 1.0 .or. p_y(i) < 1.0 .or. &
      p_x(i) > 64.0 .or. p_y(i) > 200.0) ok = .false.
enddo
if (.not.ok) call error("wrongCoords","PN BADPIX Coordinates out of range")
ok = .true.
if (p_x(0) .ne. 14 .or. p_y(0) .ne. 36) ok = .false.
if (.not.ok) call error("wrongValues","PN BADPIX Coordinate values wrong")
ok = .true.
call release(inBPXF)
!_____________________________________________________________________
write(*,*) 'testing MOS pattern (p1) projecting output'
inBPXF = dataSet("bpxfmosp1", read)
if (.not.hasBlock(inBPXF,"BADPIX")) ok = .false. 
if (.not.ok) call error("noExt","MOS Extension absent or incorrectly named")
ok = .true.
BPXFtable = table(inBPXF,"BADPIX")
xCol = column(BPXFtable, "RAWX",read)
yCol = column(BPXFtable, "RAWY",read)
p_x => int16Data(xCol)
p_y => int16Data(yCol)
if (p_x(0) .ne. 540 .or. p_y(0) .ne. 117) ok = .false.
if (.not.ok) call error("wrongValues","MOS p1 pattern wrong")
ok = .true.
call release(inBPXF)
!_____________________________________________________________________
write(*,*) 'testing MOS pattern (p5) projecting output'
inBPXF = dataSet("bpxfmosp5", read)
if (.not.hasBlock(inBPXF,"BADPIX")) ok = .false. 
if (.not.ok) call error("noExt","MOS Extension absent or incorrectly named")
ok = .true.
BPXFtable = table(inBPXF,"BADPIX")
xCol = column(BPXFtable, "RAWX",read)
yCol = column(BPXFtable, "RAWY",read)
p_x => int16Data(xCol)
p_y => int16Data(yCol)
if (p_x(1) .ne. 557 .or. p_y(1) .ne. 95) ok = .false.
if (.not.ok) call error("wrongValues","MOS p5 pattern wrong")
ok = .true.
call release(inBPXF)
!_____________________________________________________________________
write(*,*) 'testing MOS pattern (p11) projecting output'
inBPXF = dataSet("bpxfmosp11", read)
if (.not.hasBlock(inBPXF,"BADPIX")) ok = .false. 
if (.not.ok) call error("noExt","MOS Extension absent or incorrectly named")
ok = .true.
BPXFtable = table(inBPXF,"BADPIX")
xCol = column(BPXFtable, "RAWX",read)
yCol = column(BPXFtable, "RAWY",read)
p_x => int16Data(xCol)
p_y => int16Data(yCol)
if (p_x(1) .ne. 371 .or. p_y(1) .ne. 454) ok = .false.
if (.not.ok) call error("wrongValues","MOS p11 pattern wrong")
ok = .true.
call release(inBPXF)
!_____________________________________________________________________
write(*,*) 'testing MOS pattern projecting and bad event filtering output'
inBPXF = dataSet("bpxfmosbad", read)
if (.not.hasBlock(inBPXF,"BADPIX")) ok = .false. 
if (.not.ok) call error("noExt","MOS Extension absent or incorrectly named")
ok = .true.
BPXFtable = table(inBPXF,"BADPIX")
xCol = column(BPXFtable, "RAWX",read)
yCol = column(BPXFtable, "RAWY",read)
p_x => int16Data(xCol)
p_y => int16Data(yCol)
if (p_x(0) .ne. 494 .or. p_y(0) .ne. 390) ok = .false.
if (.not.ok) call error("wrongValues","MOS (bad) events file wrong")
ok = .true.
call release(inBPXF)
!_____________________________________________________________________
write(*,*) 'testing MOS flickering (KS)'
inBPXF = dataSet("bpxfmosFl", read)
if (.not.hasBlock(inBPXF,"BADPIX")) ok = .false. 
if (.not.ok) call error("noExt","MOS (FL) Extension absent or incorrectly named")
ok = .true.
BPXFtable = table(inBPXF,"BADPIX")
xCol = column(BPXFtable, "RAWX",read)
yCol = column(BPXFtable, "RAWY",read)
p_x => int16Data(xCol)
p_y => int16Data(yCol)
if (p_x(1) .ne. 200 .or. p_y(1) .ne. 300) ok = .false.
if (.not.ok) call error("wrongValues","MOS (FL) events file wrong")
ok = .true.
call release(inBPXF)
!_____________________________________________________________________
write(*,*) 'testing PN (EDGE)'
inBPXF = dataSet("bpxfpnedge", read)
if (.not.hasBlock(inBPXF,"BADPIX")) ok = .false. 
if (.not.ok) call error("noExt","PN(ALL) BADPIX Extension absent or incorrectly named")
ok = .true.
BPXFtable = table(inBPXF,"BADPIX")
xCol = column(BPXFtable, "RAWX",read)
yCol = column(BPXFtable, "RAWY",read)
p_x => int16Data(xCol)
p_y => int16Data(yCol)
if (p_x(5) .ne. 64 .or. p_y(5) .ne. 200) ok = .false.
if (.not.ok) call error("wrongValues","PN (EDGE) events file wrong [X,Y].ne.[64,200]")
ok = .true.
call release(inBPXF)
!_____________________________________________________________________
write(*,*) 'testing PN (ALL)'
inBPXF = dataSet("bpxfpnAll", read)
if (.not.hasBlock(inBPXF,"BADPIX")) ok = .false. 
if (.not.ok) call error("noExt","PN(ALL) Extension absent or incorrectly named")
ok = .true.
BPXFtable = table(inBPXF,"BADPIX")
xCol = column(BPXFtable, "RAWX",read)
yCol = column(BPXFtable, "RAWY",read)
p_x => int16Data(xCol)
p_y => int16Data(yCol)
if (p_x(0) .ne. 47 .or. p_y(0) .ne. 2) ok = .false.
if (.not.ok) call error("wrongValues","PN (ALL) events file wrong [X,Y].ne.[47,2]")
ok = .true.
call release(inBPXF)
!_____________________________________________________________________
write(*,*) 'testing MOS2 (SW)'
inBPXF = dataSet("bpxfmosSW", read)
if (.not.hasBlock(inBPXF,"BADPIX")) ok = .false. 
if (.not.ok) call error("noExt","MOS(SW) Extension absent or incorrectly named")
ok = .true.
BPXFtable = table(inBPXF,"BADPIX")
xCol = column(BPXFtable, "RAWX",read)
yCol = column(BPXFtable, "RAWY",read)
p_x => int16Data(xCol)
p_y => int16Data(yCol)
if (p_x(0) .ne. 1 .or. p_y(0) .ne. 1) ok = .false.
if (.not.ok) call error("wrongValues","MOS (SW) events file wrong")
ok = .true.
call release(inBPXF)
!_____________________________________________________________________
write(*,*) 'testing MOS2 (SWoff)'
inBPXF = dataSet("bpxfmosSWoff", read)
if (.not.hasBlock(inBPXF,"BADPIX")) ok = .false. 
if (.not.ok) call error("noExt","MOS(SW [off]) Extension absent or incorrectly named")
ok = .true.
BPXFtable = table(inBPXF,"BADPIX")
xCol = column(BPXFtable, "RAWX",read)
yCol = column(BPXFtable, "RAWY",read)
p_x => int16Data(xCol)
p_y => int16Data(yCol)
if (p_x(2) .ne. 5 .or. p_y(2) .ne. 5) ok = .false.
if (.not.ok) call error("wrongValues","MOS (SWoff) events file wrong")
ok = .true.
call release(inBPXF)
!_____________________________________________________________________
write(*,*) 'testing MOS2 (Erange)'
inBPXF = dataSet("bpxfmosE", read)
if (.not.hasBlock(inBPXF,"BADPIX")) ok = .false. 
if (.not.ok) call error("noExt","MOS(SW [off]) Extension absent or incorrectly named")
ok = .true.
BPXFtable = table(inBPXF,"BADPIX")
xCol = column(BPXFtable, "RAWX",read)
yCol = column(BPXFtable, "RAWY",read)
p_x => int16Data(xCol)
p_y => int16Data(yCol)
if (p_x(0) .ne. 20 .or. p_y(0) .ne. 10) ok = .false.
if (.not.ok) call error("wrongValues","MOS (Erange) events file wrong")
ok = .true.
call release(inBPXF)
!_____________________________________________________________________
write(*,*) 'testing MOS (realSW)'
inBPXF = dataSet("bpxfrealSW", read)
if (.not.hasBlock(inBPXF,"BADPIX")) ok = .false. 
if (.not.ok) call error("noExt","MOS(SW [real]) Extension absent or incorrectly named")
ok = .true.
BPXFtable = table(inBPXF,"BADPIX")
xCol = column(BPXFtable, "RAWX",read)
yCol = column(BPXFtable, "RAWY",read)
p_x => int16Data(xCol)
p_y => int16Data(yCol)
if (p_x(34) .ne. 349 .or. p_y(34) .ne. 304) ok = .false.
if (.not.ok) call error("wrongValues","MOS (realSW) events file wrong")
ok = .true.
call release(inBPXF)
!_____________________________________________________________________
end
